"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var query_1 = __importDefault(require("./lib/query"));
var form_body_1 = __importDefault(require("./lib/form_body"));
var json_body_1 = __importDefault(require("./lib/json_body"));
var multipart_body_1 = __importDefault(require("./lib/multipart_body"));
var content_type_1 = __importDefault(require("content-type"));
module.exports = function proxy(req, target) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, type, parameters, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    if (!target.query) return [3 /*break*/, 2];
                    return [4 /*yield*/, query_1.default(req, target)];
                case 1:
                    _c.sent();
                    _c.label = 2;
                case 2:
                    if (!target.body || Object.keys(target.body).length === 0)
                        return [2 /*return*/, target];
                    // default content-type
                    if (!req.headers['content-type']) {
                        req.headers['content-length'] = '0';
                        req.headers['content-type'] = 'application/json; charset=utf-8';
                    }
                    _a = content_type_1.default.parse(req), type = _a.type, parameters = _a.parameters;
                    _b = type;
                    switch (_b) {
                        case 'application/x-www-form-urlencoded': return [3 /*break*/, 3];
                        case 'application/json': return [3 /*break*/, 5];
                        case 'multipart/form-data': return [3 /*break*/, 7];
                    }
                    return [3 /*break*/, 9];
                case 3: return [4 /*yield*/, form_body_1.default(req, target)];
                case 4:
                    _c.sent();
                    return [3 /*break*/, 10];
                case 5: return [4 /*yield*/, json_body_1.default(req, target)];
                case 6:
                    _c.sent();
                    return [3 /*break*/, 10];
                case 7: return [4 /*yield*/, multipart_body_1.default(req, target, parameters)];
                case 8:
                    _c.sent();
                    return [3 /*break*/, 10];
                case 9:
                    target.buffer = null;
                    return [3 /*break*/, 10];
                case 10: return [2 /*return*/, target];
            }
        });
    });
};
